Scriptname DJK_DynamicJumpKey extends SKI_ConfigBase

Import DbMiscFunctions

iWant_Widgets Property iWidgets Auto

Actor Property PlayerRef Auto

Int Property DJK_MainHotKey = 45 Auto Hidden ;default left shift
Bool Property DJK_HotkeyActive = True Auto Hidden 
;Bool Property DJK_SetJumpHeightOnLoad = True Auto Hidden

Float[] Property DJK_JumpHeightMin Auto Hidden
Float[] Property DJK_JumpHeightMax Auto Hidden
Float[] Property DJK_JumpMeterSpeed Auto Hidden
Float[] Property DJK_JumpHeightUnCappedIncrement Auto Hidden
Float[] Property DJK_fJumpFallHeightMin Auto Hidden
Float[] Property DJK_fJumpStaminaRate Auto Hidden
Float[] Property DJK_SprintJumpSpeedMult Auto Hidden
Float[] Property DJK_SprintJumpSpeedBonus Auto Hidden
Float[] Property DJK_fSpeedBonusDelay Auto Hidden

Race[] Property DJK_Races Auto Hidden
Int Property DJK_RaceIndex = 0 Auto Hidden
;Int Property DJK_AddRaceIndex Auto Hidden

String[] Property DJK_MCMRaceNames Auto Hidden

Float Property DJK_JumpHeightIncrement Auto Hidden
Float Property DJK_JumpHeightHeld Auto Hidden
float Property DJK_fJumpStaminaDamage Auto Hidden


float Property fPreDynamicJumpHeight Auto Hidden

Bool Property HasJumpSpeedBonus = false Auto Hidden
String Property DJK_Strings Auto Hidden
String Property DJK_StringsFilePath = "Data/Interface/DynamicJump/DJK_Strings.txt" Auto Hidden
String[] Property DJK_DebugStrings Auto Hidden

Int Property iJumpMeter Auto Hidden
Bool Property bShowMeter = True Auto Hidden 
Bool Property bPositioningMeter = False Auto Hidden 
Int Property iMeterRotationIncrement = 45 Auto Hidden
Int Property DJK_MeterRotation = 90 Auto Hidden
Int Property DJK_MeterZoom = 70 Auto Hidden
Int Property DJK_MeterPosX = 1200 Auto Hidden
Int Property DJK_MeterPosY = 460 Auto Hidden

;for positioning the meter
Int Property UpKey = 200 Auto Hidden
Int Property DownKey = 208 Auto Hidden
Int Property LeftKey = 203 Auto Hidden
Int Property RightKey = 205 Auto Hidden
Int Property RotateModKey = 56 Auto Hidden 
Int Property ZoomModKey = 42 Auto Hidden 
Int Property AlphaModKey = 29 Auto Hidden 
Int Property SaveMeterPosKey = 28 Auto Hidden ;Enter

Bool Property DJK_ShowNotifications = False Auto Hidden

Bool Property bInitializing = True Auto Hidden

Race Property WerewolfBeastRace auto
Formlist Property DJK_VampireRaces Auto 
Formlist Property DJK_PlayerRaces Auto 

Event OnConfigInit() 
    RegisterForModEvent("iWantWidgetsReset", "OniWantWidgetsReset")
    
    Utility.Wait(3)
    Init()
    
    ;PrintStringKeysToFile("Data/Scripts/Source/DJK_DynamicJumpKey.psc", "Data/Interface/DynamicJump/DJK_StringsPrint.txt")
    ;JumpMoveMult = Game.GetGameSettingFloat("fJumpMoveMult")
EndEvent

Function Init()
    SetArrays() 
    LoadFromJson("../DJK_DynamicJump/Settings", 0)
        
    UpdateStrings()
    CalculateDJK_JumpHeightIncrement()
    ;Utility.Wait(1)
    If DJK_HotkeyActive && GetState() != "PositioningMeter"
        RegisterForkey(DJK_MainHotKey)
        GoToState("ShowMeter") 
    Endif 
    
    AddRace(WerewolfBeastRace)
    
    Race CurrentPlayerRace = PlayerRef.GetRace() 
    ;Debug.MessageBox(WerewolfBeastRace)
    If DJK_VampireRaces.Find(CurrentPlayerRace) > -1 
        AddRace(CurrentPlayerRace) 
    Else 
        Int Index = DJK_PlayerRaces.Find(CurrentPlayerRace) 
        If Index > -1 
            AddRace(DJK_VampireRaces.GetAt(Index) as race) 
        Endif 
    Endif
    
    SetSettingsForCurrentRace()
    SetDJK_MCMRaceNames()
    
    ;Debug.MessageBox(DJK_Races[1].GetName() + "\n" + DJK_Races[2])
    
    bInitializing = False
    ;Debug.Notification(GetStringFromFile("Dynamic Jump Key Installed", FilePath = DJK_StringsFilePath))
    
EndFunction

Function SetArrays() 
    If DJK_Races.Length == 0
        DJK_Races = New Race[128]
        
        DJK_JumpHeightMin = New Float[128]
        DJK_JumpHeightMax = New Float[128]
        DJK_JumpMeterSpeed = New Float[128]
        DJK_JumpHeightUnCappedIncrement = New Float[128]
        DJK_fJumpFallHeightMin = New Float[128]
        DJK_fJumpStaminaRate = New Float[128]
        DJK_SprintJumpSpeedMult = New Float[128]
        DJK_SprintJumpSpeedBonus = New Float[128]
        DJK_fSpeedBonusDelay = New Float[128]
        
        DJK_JumpHeightMin[0] = Game.GetGameSettingFloat("fJumpHeightMin") / 2
        DJK_JumpHeightMax[0] = Game.GetGameSettingFloat("fJumpHeightMin") * 2 
        DJK_JumpMeterSpeed[0] = 1.5 
        DJK_JumpHeightUnCappedIncrement[0] = 3.0
        DJK_fJumpFallHeightMin[0] = Game.GetGameSettingFloat("fJumpFallHeightMin") 
        DJK_fJumpStaminaRate[0] = 0.1
        DJK_SprintJumpSpeedMult[0] = 1.5
        DJK_SprintJumpSpeedBonus[0] = 75.0
        DJK_fSpeedBonusDelay[0] = 2.0
        
        If DJK_JumpHeightMin[0] < 1.1 
            DJK_JumpHeightMin[0] = 1.1
        Endif
    Endif
    
EndFunction

Bool Function AddRace(Race akRace, Bool WarningMessage = False) 
    ;DJK_AddRaceIndex += 1
    
    ;Debug.MessageBox(akRace + " " + Index)
    
    Int Index = DJK_Races.Find(None, 1)
    
    If akRace
        If Index == -1
            If WarningMessage
                Debug.MessageBox(GetStringFromFile("Can't add any more races", DJK_Strings))
            Endif
            Return False
            
        ElseIf DJK_Races.Find(akRace) > -1 
            If WarningMessage
                Debug.MessageBox(akRace.GetName() + " " + GetStringFromFile("OID_AddCurrentRaceWarning", DJK_Strings))
            Endif 
            Return False
        Else 
            DJK_Races[Index] = akRace 
            DJK_JumpHeightMin[Index] = DJK_JumpHeightMin[DJK_RaceIndex]
            DJK_JumpHeightMax[Index] = DJK_JumpHeightMax[DJK_RaceIndex]
            DJK_JumpMeterSpeed[Index] = DJK_JumpMeterSpeed[DJK_RaceIndex]
            DJK_JumpHeightUnCappedIncrement[Index] = DJK_JumpHeightUnCappedIncrement[DJK_RaceIndex]
            DJK_fJumpFallHeightMin[Index] = DJK_fJumpFallHeightMin[DJK_RaceIndex]
            DJK_fJumpStaminaRate[Index] = DJK_fJumpStaminaRate[DJK_RaceIndex]
            DJK_SprintJumpSpeedMult[Index] = DJK_SprintJumpSpeedMult[DJK_RaceIndex]
            DJK_SprintJumpSpeedBonus[Index] = DJK_SprintJumpSpeedBonus[DJK_RaceIndex]
            DJK_fSpeedBonusDelay[Index] = DJK_fSpeedBonusDelay[DJK_RaceIndex]
            
            ;Debug.MessageBox(DJK_Races[Index] + " " + Index)
    
            Race PlayerRace = PlayerRef.GetRace() 
            If akRace == PlayerRace
                DJK_RaceIndex = Index 
            Endif
            
            Return True
        Endif
    Endif
    
    Return False
EndFunction

Bool Function RemoveRace(Race akRace) 
    If akRace
        Int Index = DJK_Races.Find(akRace, 1) 
        If Index > -1 
            Int M = DJK_Races.Find(None, Index) 
            If M == -1 
                M = 128 
            Endif 
            
            Index += 1
            
            While Index < M && DJK_Races[Index] != None
                DJK_Races[Index - 1] = DJK_Races[Index]
                DJK_JumpHeightMin[Index - 1] = DJK_JumpHeightMin[Index]
                DJK_JumpHeightMax[Index - 1] = DJK_JumpHeightMax[Index]
                DJK_JumpMeterSpeed[Index - 1] = DJK_JumpMeterSpeed[Index]
                DJK_JumpHeightUnCappedIncrement[Index - 1] = DJK_JumpHeightUnCappedIncrement[Index]
                DJK_fJumpFallHeightMin[Index - 1] = DJK_fJumpFallHeightMin[Index]
                DJK_fJumpStaminaRate[Index - 1] = DJK_fJumpStaminaRate[Index]
                DJK_SprintJumpSpeedBonus[Index - 1] = DJK_SprintJumpSpeedBonus[Index]
                DJK_fSpeedBonusDelay[Index - 1] = DJK_fSpeedBonusDelay[Index]
                Index += 1
            EndWhile 
            
            M -= 1
            DJK_Races[M] = None 
            
            ;DJK_AddRaceIndex -= 1
        Endif
    Endif
    
    Return False
EndFunction

Event OniWantWidgetsReset(String eventName, String strArg, Float numArg, Form sender)
    ;Debug.Notification("Iwant_widgets init")
    
    If eventName == "iWantWidgetsReset"
        iWidgets = sender As iWant_Widgets
        Utility.Wait(1)
        If iWidgets 
            UnregisterForModEvent("iWantWidgetsReset")
            While bInitializing == True ;wait until done initializing to create jump meter
                Utility.WaitMenuMode(0.1) 
            EndWhile 
            CreateJumpMeter() 
            Debug.Notification(DJK_DebugStrings[0])
            ;PositionMeter()
        Endif 
    Endif
Endevent

;Formlist Property DJK_VampireRaces Auto 
;Formlist Property DJK_PlayerRAces Auto 

Function SetDJK_MCMRaceNames()
    Int I = 1 
    Int M = DJK_Races.Find(None, 1)
    If M == -1 
         M = 128
    Endif
     
    DJK_MCMRaceNames = New String[1]
    
    DJK_MCMRaceNames = Utility.ResizeStringArray(DJK_MCMRaceNames, M)
    
    DJK_MCMRaceNames[0] = GetStringFromFile("General", DJK_Strings) + " " + GetStringFromFile("Settings", DJK_Strings)
    
    
    While I < M
        If DJK_VampireRaces.Find(DJK_Races[I]) > -1 
            DJK_MCMRaceNames[I] = DJK_Races[I].GetName() + " " + GetStringFromFile("Vampire", DJK_Strings) + " " + GetStringFromFile("Settings", DJK_Strings)
        Else 
            DJK_MCMRaceNames[I] = DJK_Races[I].GetName() + " " + GetStringFromFile("Settings", DJK_Strings)
        Endif 
        
        I += 1
    EndWhile
    
EndFunction

Function SetSettingsForCurrentRace()
    Int Index =  DJK_Races.Find(PlayerRef.GetRace()) 
    If Index < 0 
        Index = 0 
    Endif 
    
    DJK_RaceIndex = Index 
        
    CalculateDJK_JumpHeightIncrement() 
    Game.SetGameSettingFloat("fJumpFallHeightMin", DJK_fJumpFallHeightMin[DJK_RaceIndex])
EndFunction

Event OnConfigOpen()
    DJK_Strings = MiscUtil.ReadFromFile(DJK_StringsFilePath)
    
    ;SetDJK_MCMRaceNames()
EndEvent

Event OnConfigClose()
    DJK_Strings = "" ;keeping a large string file in memory will cause CTD on game loads.
    SetSettingsForCurrentRace()
    
    If bPositioningMeter 
        PositionMeter() 
    Else 
        StopPositioningMeter()
    Endif
    
    SetDJK_MCMRaceNames()
EndEvent

Event OnPageReset(string page)
    Int pageIndex = Pages.Find(Page) ;find which page number was opened
    SetCursorFillMode(TOP_TO_BOTTOM)
        
    If Page == "" || PageIndex == -1 || PageIndex == 1
        
        AddKeyMapOptionST("OID_DJK_MainHotKey", GetStringFromFile("Jump Hotkey", DJK_Strings), DJK_MainHotKey)
        AddToggleOptionST("OID_DJK_HotkeyActive", GetStringFromFile("HotKey Active", DJK_Strings), DJK_HotkeyActive)
        AddToggleOptionST("OID_DJK_ShowNotifications", GetStringFromFile("Show Jump Height Notification", DJK_Strings), DJK_ShowNotifications)
        AddTextOptionST("OID_SaveToJson", GetStringFromFile("Save To Json File"), "")
        AddTextOptionST("OID_LoadFromJson", GetStringFromFile("Load From Json File"), "")
        
        SetCursorPosition(1)
        AddMenuOptionST("OID_MCMRace", GetStringFromFile("Race: "), DJK_MCMRaceNames[DJK_RaceIndex])
       
        AddInputOptionST("OID_DJK_JumpHeightMin", GetStringFromFile("Minimum Jump Height", DJK_Strings), DJK_JumpHeightMin[DJK_RaceIndex])
        AddInputOptionST("OID_DJK_JumpHeightMax", GetStringFromFile("Maximum Jump Height", DJK_Strings), DJK_JumpHeightMax[DJK_RaceIndex])
        AddInputOptionST("OID_DJK_JumpMeterSpeed", GetStringFromFile("Jump Height Increase Rate", DJK_Strings), DJK_JumpMeterSpeed[DJK_RaceIndex])
        AddInputOptionST("OID_DJK_JumpHeightUnCappedIncrement", GetStringFromFile("Uncapped Jump Height Rate", DJK_Strings), DJK_JumpHeightUnCappedIncrement[DJK_RaceIndex])
        AddInputOptionST("OID_DJK_fJumpFallHeightMin", GetStringFromFile("Minimum Fall Height Damage", DJK_Strings), DJK_fJumpFallHeightMin[DJK_RaceIndex])
        AddInputOptionST("OID_DJK_fJumpStaminaRate", GetStringFromFile("Stamina Consumption Rate", DJK_Strings), DJK_fJumpStaminaRate[DJK_RaceIndex])
        
        AddInputOptionST("OID_DJK_SprintJumpSpeedBonus", GetStringFromFile("Sprint Jump Speed Bonus", DJK_Strings), DJK_SprintJumpSpeedBonus[DJK_RaceIndex])
        AddInputOptionST("OID_DJK_fSpeedBonusDelay", GetStringFromFile("Sprint Jump Speed Bonus Delay", DJK_Strings), DJK_fSpeedBonusDelay[DJK_RaceIndex])
        
        AddEmptyOption()
        AddTextOptionST("OID_AddCurrentRace", GetStringFromFile("Add Current Race"), "")
        AddMenuOptionST("OID_RemoveMCMRace", GetStringFromFile("Remove Race"), "")
       
        
    Elseif PageIndex == 0 ;meter settings
        AddHeaderOption(GetStringFromFile("Meter Settings"))
        AddToggleOptionST("OID_bShowMeter", GetStringFromFile("Show Meter", DJK_Strings), bShowMeter)
        AddSliderOptionST("OID_iMeterRotationIncrement", GetStringFromFile("Rotation Increment"), iMeterRotationIncrement, ("{0}" + GetStringFromFile(" Degrees", DJK_Strings)))   
        
        If bPositioningMeter
            AddTextOptionST("OID_PositionMeter", GetStringFromFile("Stop Positioning Meter", DJK_Strings), "") 
        Else 
            AddTextOptionST("OID_PositionMeter", GetStringFromFile("Position Meter", DJK_Strings), "")
        Endif 
        
        SetCursorPosition(1) ;next options appear in right column
        AddHeaderOption(GetStringFromFile("Position Meter Hotkeys", DJK_Strings))
        
        AddKeyMapOptionST("OID_UpKey", GetStringFromFile("Up Key", DJK_Strings), UpKey)
        AddKeyMapOptionST("OID_DownKey", GetStringFromFile("Down Key", DJK_Strings), DownKey)
        AddKeyMapOptionST("OID_LeftKey", GetStringFromFile("Left Key", DJK_Strings), LeftKey)
        AddKeyMapOptionST("OID_RightKey", GetStringFromFile("Right Key", DJK_Strings), RightKey)
        AddKeyMapOptionST("OID_RotateModKey", GetStringFromFile("Rotate Modifier Key", DJK_Strings), RotateModKey)
        AddKeyMapOptionST("OID_ZoomModKey", GetStringFromFile("Scale Modifier Key", DJK_Strings), ZoomModKey)
    Endif
EndEvent

Function DestroyJumpMeter()
    iWidgets.sendToBack(iJumpMeter)
    iWidgets.Destroy(iJumpMeter)
    
EndFunction

Function CreateJumpMeter() 
    iJumpMeter = iWidgets.loadMeter(Visible = True)
    iWidgets.setRotation(iJumpMeter, DJK_MeterRotation)
    iWidgets.setMeterRGB(iJumpMeter, 0, 0, 0, 22, 152, 74)
    iWidgets.SetZoom(iJumpMeter, DJK_MeterZoom, DJK_MeterZoom)
    iWidgets.setTransparency(iJumpMeter, 0)
    iWidgets.SetPos(iJumpMeter, DJK_MeterPosX, DJK_MeterPosY)
    iWidgets.sendToFront(iJumpMeter)
EndFunction

Function setMeterPercentFloat(iWant_Widgets akWidget, Int id, Float percent)
    String s
    String[] value
    
    value = new String[2]
    value[0] = id As String
    value[1] = percent As String

    s = akWidget._serializeArray(value)
    UI.InvokeString(akWidget.HUD_MENU, akWidget.WidgetRoot + ".setMeterPercent", s)
EndFunction

Function TestMeter()
    ;iWidgets.SetVisible(iJumpMeter)
    ;Utility.Wait(1)
    ;
    ;iWidgets.setMeterPercent(iJumpMeter, 200)
    
    Float I = 0.0
    While I < 100.0
        I += 1.0 
        setMeterPercentFloat(iWidgets, iJumpMeter, I)
        Utility.Wait(0.001)
        ;Utility.WaitMenuMode(0.1)
    EndWhile
    
    Utility.Wait(1)
    setMeterPercentFloat(iWidgets, iJumpMeter, 0)
    
    Utility.Wait(1)
    I = 0.0
    While I < 100.0
        I += 0.5
        setMeterPercentFloat(iWidgets, iJumpMeter, I)
        Utility.Wait(0.001)
        ;Utility.WaitMenuMode(0.1)
    EndWhile
    
EndFunction

Function UpdateStrings() 
    If MiscUtil.FileExists(DJK_StringsFilePath) 
        DJK_Strings = MiscUtil.ReadFromFile(DJK_StringsFilePath)
        ;DJK_Strings = "Test CTD"
    Else 
        Debug.MessageBox("Error - DJK_Strings.txt file not found in Data/Interface/DynamicJump")
    Endif
    
    ModName = GetStringFromFile("Dynamic Jump", DJK_Strings)
    Pages = New String[2] 
    Pages[0] = GetStringFromFile("Meter Settings", DJK_Strings)
    Pages[1] = GetStringFromFile("Main Options", DJK_Strings)
    
    DJK_DebugStrings = New String[3] 
    DJK_DebugStrings[0] = GetStringFromFile("Dynamic Jump Key Installed", DJK_Strings)
    DJK_DebugStrings[1] = GetStringFromFile("Jump height: ",  DJK_Strings)
    DJK_DebugStrings[2] = GetStringFromFile("DJK_StartPositioningMeterMessage", DJK_Strings)
    Utility.WaitMenuMode(0.1)
    DJK_Strings = "" ;keeping a large string property in memory will cause CTD on game loads.
    
EndFunction

State OID_PositionMeter
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("OID_PositionMeterInfo", DJK_Strings))
    EndEvent
    
    Event OnSelectST() 
        If bPositioningMeter 
            bPositioningMeter = False
            ;StopPositioningMeter() ;done with OnConfigClose instead
        Else 
            bPositioningMeter = True
            ;PositionMeter() ;done with OnConfigClose instead
            ;Debug.MessageBox(GetStringFromFile("DJK_StartPositioningMeterMessage", DJK_Strings))
            Debug.MessageBox(DJK_DebugStrings[2])
        Endif 

        ForcePageReset()
    EndEvent
EndState

;AddSliderOptionST("OID_iMeterRotationIncrement", GetStringFromFile("Rotation Increment"), iMeterRotationIncrement, "{0} degrees")
        
State OID_iMeterRotationIncrement
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("OID_iMeterRotationIncrementInfo", DJK_Strings))
    EndEvent
    
    Event OnSliderOpenST() 
        SetSliderDialogStartValue(iMeterRotationIncrement)
        SetSliderDialogInterval(1)
        SetSliderDialogRange(1, 90)
        SetSliderDialogDefaultValue(45)
    EndEvent 
    
    Event OnSliderAcceptST(float value)
        iMeterRotationIncrement = value as int
        SetSliderOptionValueST(value, ("{0}" + GetStringFromFile(" Degrees", DJK_Strings))) 
    EndEvent
        
    
EndState

State OID_DJK_MainHotKey
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("OID_DJK_MainHotKeyInfo", DJK_Strings))
    EndEvent
    
    event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
        bool continue = true
        
        If newKeyCode == Input.GetMappedKey("Jump") 
            ShowMessage(GetStringFromFile("OID_DJK_MainHotKeyWarning", DJK_Strings))
            continue = false 
        
        Elseif (conflictControl != "")
            string msg
            if (conflictName != "")
                msg = GetStringFromFile("MCM_ConflictA", DJK_Strings) + conflictControl + "\"\n(" + conflictName + ")\n\n" + GetStringFromFile("MCM_ConflictB", DJK_Strings)
            else
                msg = GetStringFromFile("MCM_ConflictA", DJK_Strings) + conflictControl + "\"\n\n" + GetStringFromFile("MCM_ConflictB", DJK_Strings)
            endIf

            continue = ShowMessage(msg, true, "$Yes", "$No")
        endIf
        
        If (continue)
            UnregisterForKey(DJK_MainHotKey)
            Utility.WaitMenuMode(0.1)
            DJK_MainHotKey = newKeyCode
            
            If DJK_HotkeyActive == true 
                RegisterForKey(DJK_MainHotKey)
            Endif
            
            SetKeyMapOptionValueST(DJK_MainHotKey)
            
        EndIf
    EndEvent
EndState
                
state OID_DJK_HotkeyActive 
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("DJK_HotkeyActiveInfo", DJK_Strings))
    EndEvent
    
    Event OnSelectST()
        DJK_HotkeyActive = !DJK_HotkeyActive
        String asState = GetState()
        
        If DJK_HotkeyActive && asState == "Off"
            If bShowMeter == True
                GoToState("ShowMeter")
            Else
                GoToState("DontShowMeter")
            Endif 
            RegisterForKey(DJK_MainHotKey)
            
        Else
            UnRegisterForKey(DJK_MainHotKey) 
            If asState == "DontShowMeter" || asState == "ShowMeter"
                GoToState("Off")
            Endif
        Endif
        
        SetToggleOptionValueST(DJK_HotkeyActive)
    EndEvent
EndState


state OID_DJK_ShowNotifications 
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("DJK_ShowNotificationsInfo", DJK_Strings))
    EndEvent
    
    Event OnSelectST()
        DJK_ShowNotifications = !DJK_ShowNotifications
        SetToggleOptionValueST(DJK_ShowNotifications)
    EndEvent
EndState

state OID_bShowMeter 
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("bShowMeterInfo", DJK_Strings))
    EndEvent
    
    Event OnSelectST()
        bShowMeter = !bShowMeter
        
        If bShowMeter == True
            CreateJumpMeter()
        Else
            DestroyJumpMeter()
        Endif 
        
        SetToggleOptionValueST(bShowMeter)
    EndEvent
EndState

State OID_UpKey
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("OID_UpKeyInfo", DJK_Strings))
    EndEvent
    
    event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
        bool continue = true
        
        If (continue)
            UnregisterForKey(UpKey)
            Utility.WaitMenuMode(0.1)
            UpKey = newKeyCode
            
            If GetState() == "PositioningMeter"
                RegisterForKey(UpKey)
            Endif
            
            SetKeyMapOptionValueST(UpKey)
        EndIf
    EndEvent
EndState

State OID_DownKey
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("OID_DownKeyInfo", DJK_Strings))
    EndEvent
    
    event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
        bool continue = true
 
        If (continue)
            UnregisterForKey(DownKey)
            Utility.WaitMenuMode(0.1)
            DownKey = newKeyCode
            
            If GetState() == "PositioningMeter"
                RegisterForKey(DownKey)
            Endif
            
            SetKeyMapOptionValueST(DownKey)
        EndIf
    EndEvent
EndState

State OID_LeftKey
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("OID_LeftKeyInfo", DJK_Strings))
    EndEvent
    
    event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
        bool continue = true
 
        If (continue)
            UnregisterForKey(LeftKey)
            Utility.WaitMenuMode(0.1)
            LeftKey = newKeyCode
            
            If GetState() == "PositioningMeter"
                RegisterForKey(LeftKey)
            Endif
            
            SetKeyMapOptionValueST(LeftKey)
        EndIf
    EndEvent
EndState

State OID_RightKey
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("OID_RightKeyInfo", DJK_Strings))
    EndEvent
    
    event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
        bool continue = true

        If (continue)
            UnregisterForKey(RightKey)
            Utility.WaitMenuMode(0.1)
            RightKey = newKeyCode
            
            If GetState() == "PositioningMeter"
                RegisterForKey(RightKey)
            Endif
            
            SetKeyMapOptionValueST(RightKey)
        EndIf
    EndEvent
EndState

State OID_RotateModKey
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("OID_RotateModKeyInfo", DJK_Strings))
    EndEvent
    
    event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
        bool continue = true

        If (continue)
            Utility.WaitMenuMode(0.1)
            RotateModKey = newKeyCode
            
            SetKeyMapOptionValueST(RotateModKey)
        EndIf
    EndEvent
EndState

State OID_ZoomModKey
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("OID_ZoomModKeyInfo", DJK_Strings))
    EndEvent
    
    event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
        bool continue = true
        
        If (continue)
            Utility.WaitMenuMode(0.1)
            ZoomModKey = newKeyCode
            
            SetKeyMapOptionValueST(ZoomModKey)
        EndIf
    EndEvent
EndState

;AddMenuOptionST("OID_MCMRace", GetStringFromFile("Race: "), DJK_Races[DJK_RaceIndex])
       
State OID_MCMRace 
    Event OnHighlightST() 
        SetInfoText(GetStringFromFile("OID_MCMRaceInfo", DJK_Strings))
    EndEvent
    
    Event OnMenuOpenST()
        SetMenuDialogStartIndex(DJK_RaceIndex)
        SetMenuDialogDefaultIndex(0)
        SetMenuDialogOptions(DJK_MCMRaceNames)
    EndEvent

    Event OnMenuAcceptST(int a_index)
        If a_index > -1 
            DJK_RaceIndex = a_index
            ForcePageReset()
        Endif
    EndEvent
EndState 

State OID_AddCurrentRace 
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("OID_AddCurrentRaceInfo", DJK_Strings))
    EndEvent
    
    Event OnSelectST() 
        Race PlayerRace = PlayerRef.GetRace()
        
        String RaceName = PlayerRace.GetName() 
    
        If DJK_VampireRaces.Find(PlayerRace) > -1
            RaceName += " " + GetStringFromFile("Vampire", DJK_Strings)
        Endif 
        
        String ConfirmMessage = GetStringFromFile("Add the", DJK_Strings) + " " + RaceName + " " + GetStringFromFile("DJK_AddRaceConfirm", DJK_Strings)
        If ShowMessage(ConfirmMessage)
            If AddRace(PlayerRace, True) == True
                SetDJK_MCMRaceNames()
                ForcePageReset()
            Endif
        Endif
      
    EndEvent
EndState 

State OID_RemoveMCMRace 
    Event OnHighlightST() 
        SetInfoText(GetStringFromFile("OID_RemoveMCMRaceInfo", DJK_Strings))
    EndEvent
    
    Event OnMenuOpenST()
        SetMenuDialogStartIndex(DJK_RaceIndex)
        SetMenuDialogDefaultIndex(0)
        SetMenuDialogOptions(DJK_MCMRaceNames)
    EndEvent

    Event OnMenuAcceptST(int a_index)
        If a_index > 0
            If ShowMessage(GetStringFromFile("Remove the", DJK_Strings) + " " + DJK_Races[a_index].GetName() + " " + GetStringFromFile("DJK_RemoveRaceConfirm", DJK_Strings))
                RemoveRace(DJK_Races[a_index])
                If DJK_RaceIndex >= a_index
                    DJK_RaceIndex -= 1
                Endif 
                
                Utility.WaitMenuMode(1)
                SetDJK_MCMRaceNames()
                ForcePageReset()
            Endif 
        Endif
    EndEvent
EndState 

state OID_DJK_JumpHeightMin
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("DJK_JumpHeightMinInfo", DJK_Strings))
    EndEvent

    Event OnInputOpenST()
        SetInputDialogStartText(DJK_JumpHeightMin[DJK_RaceIndex])
    EndEvent
    
    Event OnInputAcceptST(string sinput)
        If sinput != "" ;did the user actually input something?
            If (IsNumber(sinput) == true) ;did the user input a number?
                Float Value = (sinput as Float)
                
                If Value < 1.1 ;jump height can't go below 1.1
                    Value = 1.1
                Endif 
                
                if Value > DJK_JumpHeightMax[DJK_RaceIndex] 
                    DJK_JumpHeightMax[DJK_RaceIndex] = Value 
                    SetInputOptionValueST(DJK_JumpHeightMax[DJK_RaceIndex], false, "OID_DJK_JumpHeightMax")
                Endif
                
                DJK_JumpHeightMin[DJK_RaceIndex] = Value
                SetInputOptionValueST(DJK_JumpHeightMin[DJK_RaceIndex])
                
            Else 
                ShowMessage(GetStringFromFile("Only enter numbers", DJK_Strings), false)
            Endif
        Endif
    EndEvent
EndState

state OID_DJK_JumpHeightMax
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("DJK_JumpHeightMaxInfo", DJK_Strings))
    EndEvent

    Event OnInputOpenST()
        SetInputDialogStartText(DJK_JumpHeightMax[DJK_RaceIndex])
    EndEvent
    
    Event OnInputAcceptST(string sinput)
        If sinput != "" ;did the user actually input something?
            If (IsNumber(sinput) == true) ;did the user input a number?
                Float Value = (sinput as Float)
                
                If Value > 0
                    If Value < DJK_JumpHeightMin[DJK_RaceIndex] 
                        Value = DJK_JumpHeightMin[DJK_RaceIndex] 
                    Endif
                Endif
                
                DJK_JumpHeightMax[DJK_RaceIndex] = Value
                SetInputOptionValueST(DJK_JumpHeightMax[DJK_RaceIndex])
                
            Else 
                ShowMessage(GetStringFromFile("Only enter numbers", DJK_Strings), false)
            Endif
        Endif
    EndEvent
EndState

state OID_DJK_JumpHeightUnCappedIncrement
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("DJK_JumpHeightUnCappedIncrementInfo", DJK_Strings))
    EndEvent

    Event OnInputOpenST()
        SetInputDialogStartText(DJK_JumpHeightUnCappedIncrement[DJK_RaceIndex])
    EndEvent
    
    Event OnInputAcceptST(string sinput)
        If sinput != "" ;did the user actually input something?
            If (IsNumber(sinput) == true) ;did the user input a number?
                Float Value = (sinput as Float)
                
                If Value < 1
                    Value = 1
                Endif
                
                DJK_JumpHeightUnCappedIncrement[DJK_RaceIndex] = Value
                SetInputOptionValueST(DJK_JumpHeightUnCappedIncrement[DJK_RaceIndex])
                
            Else 
                ShowMessage(GetStringFromFile("Only enter numbers", DJK_Strings), false)
            Endif
        Endif
    EndEvent
EndState

state OID_DJK_JumpMeterSpeed
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("DJK_JumpMeterSpeedInfo", DJK_Strings))
    EndEvent

    Event OnInputOpenST()
        SetInputDialogStartText(DJK_JumpMeterSpeed[DJK_RaceIndex])
    EndEvent
    
    Event OnInputAcceptST(string sinput)
        If sinput != "" ;did the user actually input something?
            If (IsNumber(sinput) == true) ;did the user input a number?
                Float Value = (sinput as Float)
                
                DJK_JumpMeterSpeed[DJK_RaceIndex] = Value
                SetInputOptionValueST(DJK_JumpMeterSpeed[DJK_RaceIndex])
            Else 
                ShowMessage(GetStringFromFile("Only enter numbers", DJK_Strings), false)
            Endif
        Endif
    EndEvent
EndState

state OID_DJK_fJumpFallHeightMin
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("DJK_fJumpFallHeightMinInfo", DJK_Strings))
    EndEvent

    Event OnInputOpenST()
        SetInputDialogStartText(DJK_fJumpFallHeightMin[DJK_RaceIndex])
    EndEvent
    
    Event OnInputAcceptST(string sinput)
        If sinput != "" ;did the user actually input something?
            If (IsNumber(sinput) == true) ;did the user input a number?
                Float Value = (sinput as Float)
                
                If Value < 1 
                    Value = 1
                Endif
                
                ;Game.SetGameSettingFloat("fJumpFallHeightMin", (Value))
                DJK_fJumpFallHeightMin[DJK_RaceIndex] = Value
                SetInputOptionValueST(DJK_fJumpFallHeightMin[DJK_RaceIndex])
            Else 
                ShowMessage(GetStringFromFile("Only enter numbers", DJK_Strings), false)
            Endif
        Endif
    EndEvent
EndState
        
state OID_DJK_fJumpStaminaRate
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("DJK_fJumpStaminaRateInfo", DJK_Strings))
    EndEvent

    Event OnInputOpenST()
        SetInputDialogStartText(DJK_fJumpStaminaRate[DJK_RaceIndex])
    EndEvent
    
    Event OnInputAcceptST(string sinput)
        If sinput != "" ;did the user actually input something?
            If (IsNumber(sinput) == true) ;did the user input a number?
                Float Value = (sinput as Float)
                
                If Value < 0.0
                    Value = 0.0
                Endif
                
                SetInputOptionValueST(Value)
                DJK_fJumpStaminaRate[DJK_RaceIndex] = Value
            Else 
                ShowMessage(GetStringFromFile("Only enter numbers", DJK_Strings), false)
            Endif
        Endif
    EndEvent
EndState

state OID_DJK_SprintJumpSpeedBonus
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("DJK_SprintJumpSpeedBonusInfo", DJK_Strings))
    EndEvent

    Event OnInputOpenST()
        SetInputDialogStartText(DJK_SprintJumpSpeedBonus[DJK_RaceIndex])
    EndEvent
    
    Event OnInputAcceptST(string sinput)
        If sinput != "" ;did the user actually input something?
            If (IsNumber(sinput) == true) ;did the user input a number?
                Float Value = (sinput as Float)
                
                If Value < 1.0 ;can't go below 1.0
                    Value = 1.0
                Endif
                
                DJK_SprintJumpSpeedBonus[DJK_RaceIndex] = Value
                SetInputOptionValueST(DJK_SprintJumpSpeedBonus[DJK_RaceIndex])
            Else 
                ShowMessage(GetStringFromFile("Only enter numbers", DJK_Strings), false)
            Endif
        Endif
    EndEvent
EndState

state OID_DJK_fSpeedBonusDelay
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("DJK_fSpeedBonusDelayInfo", DJK_Strings))
    EndEvent

    Event OnInputOpenST()
        SetInputDialogStartText(DJK_fSpeedBonusDelay[DJK_RaceIndex])
    EndEvent
    
    Event OnInputAcceptST(string sinput)
        If sinput != "" ;did the user actually input something?
            If (IsNumber(sinput) == true) ;did the user input a number?
                Float Value = (sinput as Float)
                
                If Value < 0.1 ;can't go below 0.1
                    Value = 0.1
                Endif
                
                DJK_fSpeedBonusDelay[DJK_RaceIndex] = Value
                SetInputOptionValueST(DJK_fSpeedBonusDelay[DJK_RaceIndex])
            Else 
                ShowMessage(GetStringFromFile("Only enter numbers", DJK_Strings), false)
            Endif
        Endif
    EndEvent
EndState

;AddTextOptionST("OID_SaveToJson", GetStringFromFile("Save To Json File"), "")
;AddTextOptionST("OID_LoadFromJson", GetStringFromFile("Load From Json File"), "")
        

State OID_SaveToJson 
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("OID_SaveToJsonInfo", DJK_Strings))
    EndEvent
    
    Event OnSelectST() 
        If ShowMessage(GetStringFromFile("OID_SaveToJsonConfirm", DJK_Strings))
            SaveToJson("../DJK_DynamicJump/Settings", 2, GetStringFromFile("Settings Saved", DJK_Strings))
        Endif 
    EndEvent
            
EndState 

State OID_LoadFromJson
    Event OnHighlightST()
        SetInfoText(GetStringFromFile("OID_LoadFromJsonInfo", DJK_Strings))
    EndEvent
    
    Event OnSelectST() 
         If ShowMessage(GetStringFromFile("OID_LoadFromJsonConfirm", DJK_Strings))
             LoadFromJson("../DJK_DynamicJump/Settings", 2, GetStringFromFile("JsonCorruptedWarning", DJK_Strings), GetStringFromFile("SettingNotFoundWarning", DJK_Strings), GetStringFromFile("Settings Loaded", DJK_Strings))
        Endif 
    EndEvent
    
EndState

State ShowMeter
    Event OnKeyDown(Int keyCode)
        If Utility.IsInMenuMode() == false && UI.IsTextInputEnabled() == False && PlayerRef.IsSneaking() == False
            
            DJK_fJumpStaminaDamage = 0.0
            DJK_JumpHeightHeld = DJK_JumpHeightMin[DJK_RaceIndex]
            iWidgets.doTransitionByTime(iJumpMeter, 100, 1.0)
            Float I = 0.0
                
            If DJK_JumpHeightMax[DJK_RaceIndex] > 0 ;capped
            
                While Input.IsKeyPressed(DJK_MainHotKey) && I <= 100.0 && DJK_fJumpStaminaDamage < PlayerRef.GetActorValue("Stamina")
                    I += DJK_JumpMeterSpeed[DJK_RaceIndex]
                    DJK_JumpHeightHeld += DJK_JumpHeightIncrement
                    DJK_fJumpStaminaDamage = (DJK_JumpHeightHeld * DJK_fJumpStaminaRate[DJK_RaceIndex])
                    setMeterPercentFloat(iWidgets, iJumpMeter, I)
                    Utility.Wait(0.001)
                    
                EndWhile
                
                While Input.IsKeyPressed(DJK_MainHotKey) && DJK_fJumpStaminaDamage < PlayerRef.GetActorValue("Stamina")
                    DJK_JumpHeightHeld += DJK_JumpHeightIncrement
                    DJK_fJumpStaminaDamage = (DJK_JumpHeightHeld * DJK_fJumpStaminaRate[DJK_RaceIndex])
                    Utility.Wait(0.001)
                    
                EndWhile
                
            Else ;UnCapped 
                If DJK_fJumpStaminaRate[DJK_RaceIndex] == 0.0
                    While Input.IsKeyPressed(DJK_MainHotKey) && I <= 100.0
                        I += 0.25
                        DJK_JumpHeightHeld += DJK_JumpHeightUnCappedIncrement[DJK_RaceIndex]
                        setMeterPercentFloat(iWidgets, iJumpMeter, I)
                        Utility.Wait(0.001)
                        
                    EndWhile
                    
                    While Input.IsKeyPressed(DJK_MainHotKey)
                        DJK_JumpHeightHeld += DJK_JumpHeightUnCappedIncrement[DJK_RaceIndex]
                        Utility.Wait(0.001)
                    EndWhile
                Else 
                    While Input.IsKeyPressed(DJK_MainHotKey) && DJK_fJumpStaminaDamage < PlayerRef.GetActorValue("Stamina")
                        DJK_JumpHeightHeld += DJK_JumpHeightUnCappedIncrement[DJK_RaceIndex]
                        DJK_fJumpStaminaDamage = (DJK_JumpHeightHeld * DJK_fJumpStaminaRate[DJK_RaceIndex])
                        setMeterPercentFloat(iWidgets, iJumpMeter, DJK_fJumpStaminaDamage / PlayerRef.GetActorValue("Stamina")) ;meter shows how much stamina is left to consume for jump.   
                        Utility.Wait(0.001)
                    EndWhile
                Endif 
            Endif
        Endif
    EndEvent
    
    Event OnKeyUp(Int keyCode, Float holdTime)
        If Utility.IsInMenuMode() == false && UI.IsTextInputEnabled() == False
            If PlayerRef.IsSneaking() 
                iWidgets.doTransitionByTime(iJumpMeter, 0, 2.5)
                Return 
            Endif 
            
            If DJK_JumpHeightMax[DJK_RaceIndex] > 0 ;0 = uncapped
                If DJK_JumpHeightHeld > DJK_JumpHeightMax[DJK_RaceIndex] 
                    DJK_JumpHeightHeld = DJK_JumpHeightMax[DJK_RaceIndex]
                    DJK_fJumpStaminaDamage = (DJK_JumpHeightHeld * DJK_fJumpStaminaRate[DJK_RaceIndex])
                Endif 
            Endif 
            
            If PlayerRef.IsSprinting()
                If HasJumpSpeedBonus == False
                    HasJumpSpeedBonus = True
                    PlayerRef.ModActorValue("SpeedMult", DJK_SprintJumpSpeedBonus[DJK_RaceIndex])
                    PlayerRef.ModActorValue("InventoryWeight", - 0.01) ;make the change to speedmult apply
                    PlayerRef.ModActorValue("InventoryWeight", - 0.1)
                Endif
            Endif
            
            fPreDynamicJumpHeight = Game.GetGameSettingFloat("fJumpHeightMin")
            Game.SetGameSettingFloat("fJumpHeightMin", DJK_JumpHeightHeld)
            
            If DJK_ShowNotifications
                ;Debug.Notification(GetStringFromFile("Jump height = ",  DJK_Strings) + DJK_JumpHeightMin[DJK_RaceIndex])
                Debug.Notification(DJK_DebugStrings[1] + DJK_JumpHeightHeld)
            Endif
            
            Utility.Wait(0.01)
            
            Input.TapKey(Input.GetMappedKey("Jump"))
            If ISGodModeEnabled() == False
                PlayerRef.DamageActorValue("Stamina", DJK_fJumpStaminaDamage)
            Endif
            
            RegisterForSingleUpdate(DJK_fSpeedBonusDelay[DJK_RaceIndex])
            Utility.Wait(0.5)
            
            Game.SetGameSettingFloat("fJumpHeightMin", (fPreDynamicJumpHeight))
            
            ;iWidgets.setTransparency(iJumpMeter, 0)
            iWidgets.doTransitionByTime(iJumpMeter, 0, 2.5)
        Endif
    EndEvent
    
    Event OnUpdate()
        If HasJumpSpeedBonus 
            PlayerRef.ModActorValue("SpeedMult", -DJK_SprintJumpSpeedBonus[DJK_RaceIndex])
            PlayerRef.ModActorValue("InventoryWeight", - 0.01) ;make the change to speedmult apply
            PlayerRef.ModActorValue("InventoryWeight", - 0.1)
            HasJumpSpeedBonus = False
        Endif 
    EndEvent
EndState

State DontShowMeter 
     Event OnKeyDown(Int keyCode)
        If Utility.IsInMenuMode() == false && UI.IsTextInputEnabled() == False && PlayerRef.IsSneaking() == False
            
            DJK_fJumpStaminaDamage = 0.0
            DJK_JumpHeightHeld = DJK_JumpHeightMin[DJK_RaceIndex]
            ;iWidgets.doTransitionByTime(iJumpMeter, 100, 1.0)
            Float I = 0.0
                
            If DJK_JumpHeightMax[DJK_RaceIndex] > 0 ;capped
            
                While Input.IsKeyPressed(DJK_MainHotKey) && DJK_fJumpStaminaDamage < PlayerRef.GetActorValue("Stamina")
                    DJK_JumpHeightHeld += DJK_JumpHeightIncrement
                    DJK_fJumpStaminaDamage = (DJK_JumpHeightHeld * DJK_fJumpStaminaRate[DJK_RaceIndex])
                    Utility.Wait(0.001)
                    
                EndWhile
                
            Else ;UnCapped 
                If DJK_fJumpStaminaRate[DJK_RaceIndex] == 0.0
                    While Input.IsKeyPressed(DJK_MainHotKey)
                        DJK_JumpHeightHeld += DJK_JumpHeightUnCappedIncrement[DJK_RaceIndex]
                        Utility.Wait(0.001)
                    EndWhile
                Else 
                    While Input.IsKeyPressed(DJK_MainHotKey) && DJK_fJumpStaminaDamage < PlayerRef.GetActorValue("Stamina")
                        DJK_JumpHeightHeld += DJK_JumpHeightUnCappedIncrement[DJK_RaceIndex]
                        DJK_fJumpStaminaDamage = (DJK_JumpHeightHeld * DJK_fJumpStaminaRate[DJK_RaceIndex])
                        ;setMeterPercentFloat(iWidgets, iJumpMeter, DJK_fJumpStaminaDamage / PlayerRef.GetActorValue("Stamina")) ;meter shows how much stamina is left to consume for jump.   
                        Utility.Wait(0.001)
                    EndWhile
                Endif 
            Endif
        Endif
    EndEvent
    
    Event OnKeyUp(Int keyCode, Float holdTime) 
        If Utility.IsInMenuMode() == false && UI.IsTextInputEnabled() == False && PlayerRef.IsSneaking() == False
            If DJK_JumpHeightMax[DJK_RaceIndex] > 0 ;0 = uncapped
                If DJK_JumpHeightHeld > DJK_JumpHeightMax[DJK_RaceIndex] 
                    DJK_JumpHeightHeld = DJK_JumpHeightMax[DJK_RaceIndex]
                    DJK_fJumpStaminaDamage = (DJK_JumpHeightHeld * DJK_fJumpStaminaRate[DJK_RaceIndex])
                Endif 
            Endif 
            
            If PlayerRef.IsSprinting()
                If HasJumpSpeedBonus == False
                    HasJumpSpeedBonus = True
                    PlayerRef.ModActorValue("SpeedMult", DJK_SprintJumpSpeedBonus[DJK_RaceIndex])
                Endif
            Endif
            
            fPreDynamicJumpHeight = Game.GetGameSettingFloat("fJumpHeightMin")
            Game.SetGameSettingFloat("fJumpHeightMin", DJK_JumpHeightHeld)
            
            If DJK_ShowNotifications
                ;Debug.Notification(GetStringFromFile("Jump height = ",  DJK_Strings) + DJK_JumpHeightMin[DJK_RaceIndex])
                Debug.Notification(DJK_DebugStrings[1] + DJK_JumpHeightHeld)
            Endif
            
            Utility.Wait(0.01)
            
            Input.TapKey(Input.GetMappedKey("Jump"))
            If ISGodModeEnabled() == False
                PlayerRef.DamageActorValue("Stamina", DJK_fJumpStaminaDamage)
            Endif
            
            RegisterForSingleUpdate(DJK_fSpeedBonusDelay[DJK_RaceIndex])
            Utility.Wait(0.5)
            
            Game.SetGameSettingFloat("fJumpHeightMin", (fPreDynamicJumpHeight))
            
            ;iWidgets.setTransparency(iJumpMeter, 0)
            iWidgets.doTransitionByTime(iJumpMeter, 0, 2.5)
        Endif
    EndEvent
    
    Event OnUpdate()
        If HasJumpSpeedBonus 
            PlayerRef.ModActorValue("SpeedMult", -DJK_SprintJumpSpeedBonus[DJK_RaceIndex])
            HasJumpSpeedBonus = False
        Endif 
    EndEvent
EndState

State Off 
    
    
EndState


Function CalculateDJK_JumpHeightIncrement() 
    If DJK_JumpHeightMax[DJK_RaceIndex] == 0 ;uncapped. 
        DJK_JumpHeightIncrement = 2.5
    Else 
        DJK_JumpHeightIncrement = (DJK_JumpHeightMax[DJK_RaceIndex] - DJK_JumpHeightMin[DJK_RaceIndex]) * (DJK_JumpMeterSpeed[DJK_RaceIndex] * 0.01 * 1.2)
    Endif
EndFunction

Function PositionMeter() 
    If bShowMeter == False 
        CreateJumpMeter()
    Endif 
    
    bPositioningMeter = true
    UnregisterForAllKeys()
    iWidgets.doTransitionByTime(iJumpMeter, 100, 1.5)
    setMeterPercentFloat(iWidgets, iJumpMeter, 75.0)
    GoToState("PositioningMeter")
    RegisterForKey(UpKey)
    RegisterForKey(DownKey)
    RegisterForKey(LeftKey)
    RegisterForKey(RightKey)
    RegisterForKey(SaveMeterPosKey)
    
EndFunction 

;Int Property DJK_MainHotKey = 45 Auto Hidden ;default left shift
;Bool Property DJK_HotkeyActive = True Auto Hidden 

Function StopPositioningMeter()
    UnregisterForAllKeys()
    bPositioningMeter = false 
    
    iWidgets.doTransitionByTime(iJumpMeter, 0, 1.5) ;fade out meter
    
    If DJK_HotkeyActive 
        RegisterForKey(DJK_MainHotKey)
        If bShowMeter 
            GoToState("ShowMeter") 
        Else 
            GoToState("DontShowMeter") 
        Endif
    Else 
        GoToState("OFf")
    Endif
    
    setMeterPercentFloat(iWidgets, iJumpMeter, 0)
    
    If bShowMeter == False 
        DestroyJumpMeter()
    Endif
    
EndFunction

State PositioningMeter
    Event OnKeyDown(Int keyCode) 
        If keyCode == SaveMeterPosKey 
            StopPositioningMeter()
            
        ElseIf Input.IsKeyPressed(RotateModKey)
            Float Delay = 0.5
            
            If keyCode == UpKey
                DJK_MeterRotation += iMeterRotationIncrement 
                If DJK_MeterRotation > 360 
                    DJK_MeterRotation -= 360
                Endif 
                iWidgets.setRotation(iJumpMeter, DJK_MeterRotation)
                
                Utility.Wait(Delay)
                
                If iMeterRotationIncrement == 1
                    While Input.IsKeyPressed(UpKey) 
                        DJK_MeterRotation += 1 
                        If DJK_MeterRotation > 360 
                            DJK_MeterRotation = 0 
                        Endif 
                        iWidgets.setRotation(iJumpMeter, DJK_MeterRotation)
                        Utility.Wait(0.001)
                    EndWhile 
                Endif
                
            Elseif KeyCode == RightKey
                DJK_MeterRotation += iMeterRotationIncrement 
                If DJK_MeterRotation > 360 
                    DJK_MeterRotation -= 360
                Endif  
                iWidgets.setRotation(iJumpMeter, DJK_MeterRotation)
                
                Utility.Wait(Delay)
                
                If iMeterRotationIncrement == 1
                    While Input.IsKeyPressed(RightKey) 
                        DJK_MeterRotation += 1 
                        If DJK_MeterRotation > 360 
                            DJK_MeterRotation = 0 
                        Endif 
                        iWidgets.setRotation(iJumpMeter, DJK_MeterRotation)
                        Utility.Wait(0.001)
                    EndWhile 
                Endif
                
            Elseif keyCode == DownKey
                DJK_MeterRotation -= iMeterRotationIncrement
                If DJK_MeterRotation < 0 
                    DJK_MeterRotation += 360
                Endif 
                iWidgets.setRotation(iJumpMeter, DJK_MeterRotation)
                
                Utility.Wait(Delay)
                If iMeterRotationIncrement == 1
                    While Input.IsKeyPressed(DownKey) 
                        DJK_MeterRotation -= 1 
                        If DJK_MeterRotation < 0 
                            DJK_MeterRotation = 360
                        Endif
                        iWidgets.setRotation(iJumpMeter, DJK_MeterRotation)
                        Utility.Wait(0.001)
                    EndWhile 
                Endif
                
            Elseif keyCode == leftKey
                DJK_MeterRotation -= iMeterRotationIncrement
                If DJK_MeterRotation < 0 
                    DJK_MeterRotation += 360
                Endif 
                iWidgets.setRotation(iJumpMeter, DJK_MeterRotation)
                
                Utility.Wait(Delay)
                If iMeterRotationIncrement == 1
                    While Input.IsKeyPressed(leftKey) 
                        DJK_MeterRotation -= 1 
                        If DJK_MeterRotation < 0 
                            DJK_MeterRotation = 360
                        Endif
                        iWidgets.setRotation(iJumpMeter, DJK_MeterRotation)
                        Utility.Wait(0.001)
                    EndWhile 
                Endif
            Endif
            
        Elseif Input.IsKeyPressed(ZoomModKey)
            If keyCode == UpKey
                DJK_MeterZoom += 1 
                iWidgets.setZoom(iJumpMeter, DJK_MeterZoom, DJK_MeterZoom) 
                
                Utility.Wait(0.2)
                While Input.IsKeyPressed(UpKey) 
                    DJK_MeterZoom += 1 
                    iWidgets.setZoom(iJumpMeter, DJK_MeterZoom, DJK_MeterZoom) 
                    Utility.Wait(0.001)
                EndWhile
                    
            Elseif keyCode == DownKey
                If DJK_MeterZoom > 1
                    DJK_MeterZoom -= 1 
                Endif 
                
                iWidgets.setZoom(iJumpMeter, DJK_MeterZoom, DJK_MeterZoom) 
                
                Utility.Wait(0.2)
                While Input.IsKeyPressed(DownKey) && DJK_MeterZoom > 1
                    DJK_MeterZoom -= 1 
                    iWidgets.setZoom(iJumpMeter, DJK_MeterZoom, DJK_MeterZoom) 
                    Utility.Wait(0.001)
                EndWhile
            Endif
        Else 
            If keyCode == UpKey
                DJK_MeterPosY -= 1 
                iWidgets.SetPos(iJumpMeter, DJK_MeterPosX, DJK_MeterPosY)
                
                Utility.Wait(0.5) 
                While Input.IsKeyPressed(UpKey) 
                    DJK_MeterPosY -= 1 
                    iWidgets.SetPos(iJumpMeter, DJK_MeterPosX, DJK_MeterPosY)
                    Utility.Wait(0.001)
                EndWhile
                
    
            Elseif keyCode == DownKey
                DJK_MeterPosY += 1 
                iWidgets.SetPos(iJumpMeter, DJK_MeterPosX, DJK_MeterPosY)
                
                Utility.Wait(0.5) 
                While Input.IsKeyPressed(DownKey) 
                    DJK_MeterPosY += 1 
                    iWidgets.SetPos(iJumpMeter, DJK_MeterPosX, DJK_MeterPosY)
                    Utility.Wait(0.001)
                EndWhile
                
            Elseif keyCode == LeftKey
                DJK_MeterPosX -= 1 
                iWidgets.SetPos(iJumpMeter, DJK_MeterPosX, DJK_MeterPosY)
                
                Utility.Wait(0.5) 
                While Input.IsKeyPressed(LeftKey) 
                    DJK_MeterPosX -= 1 
                    iWidgets.SetPos(iJumpMeter, DJK_MeterPosX, DJK_MeterPosY)
                    Utility.Wait(0.001)
                EndWhile
                
            Elseif keyCode == RightKey
                DJK_MeterPosX += 1 
                iWidgets.SetPos(iJumpMeter, DJK_MeterPosX, DJK_MeterPosY)
                
                Utility.Wait(0.5) 
                While Input.IsKeyPressed(RightKey) 
                    DJK_MeterPosX += 1 
                    iWidgets.SetPos(iJumpMeter, DJK_MeterPosX, DJK_MeterPosY)
                    Utility.Wait(0.001)
                EndWhile
            Endif
        Endif 
    EndEvent
EndState

Function SaveToJson(String JsonFileName, Int Messages = 0, String ConfirmMsg = "Settings Saved")
     Int I = 0
     Int M = DJK_Races.Find(None, 1)
     If M == -1 
         M = 128
     Endif
     
     While I < M
         JsonUtil.SetFormValue(JsonFileName, ("DJK_Races" + I), DJK_Races[I])
         JsonUtil.SetFloatValue(JsonFileName, ("DJK_JumpHeightMin" + I), DJK_JumpHeightMin[I])
         JsonUtil.SetFloatValue(JsonFileName, ("DJK_JumpHeightMax" + I), DJK_JumpHeightMax[I])
         JsonUtil.SetFloatValue(JsonFileName, ("DJK_JumpMeterSpeed" + I), DJK_JumpMeterSpeed[I])
         JsonUtil.SetFloatValue(JsonFileName, ("DJK_JumpHeightUnCappedIncrement" + I), DJK_JumpHeightUnCappedIncrement[I])
         JsonUtil.SetFloatValue(JsonFileName, ("DJK_fJumpFallHeightMin" + I), DJK_fJumpFallHeightMin[I])
         JsonUtil.SetFloatValue(JsonFileName, ("DJK_fJumpStaminaRate" + I), DJK_fJumpStaminaRate[I])
         JsonUtil.SetFloatValue(JsonFileName, ("DJK_SprintJumpSpeedBonus" + I), DJK_SprintJumpSpeedBonus[I])
         JsonUtil.SetFloatValue(JsonFileName, ("DJK_fSpeedBonusDelay" + I), DJK_fSpeedBonusDelay[I])
         I += 1
     EndWhile
     
     While I < 128 
         JsonUtil.UnsetFormValue(JsonFileName, ("DJK_Races" + I))
         JsonUtil.UnsetFloatValue(JsonFileName, ("DJK_JumpHeightMin"))
         JsonUtil.UnsetFloatValue(JsonFileName, ("DJK_JumpHeightMax" + I))
         JsonUtil.UnsetFloatValue(JsonFileName, ("DJK_JumpMeterSpeed" + I))
         JsonUtil.UnsetFloatValue(JsonFileName, ("DJK_JumpHeightUnCappedIncrement" + I))
         JsonUtil.UnsetFloatValue(JsonFileName, ("DJK_fJumpFallHeightMin" + I))
         JsonUtil.UnsetFloatValue(JsonFileName, ("DJK_fJumpStaminaRate" + I))
         JsonUtil.UnsetFloatValue(JsonFileName, ("DJK_SprintJumpSpeedBonus" + I))
         JsonUtil.UnsetFloatValue(JsonFileName, ("DJK_fSpeedBonusDelay" + I))
         I += 1
     EndWhile
         
     
     JsonUtil.SetIntValue(JsonFileName, "DJK_MainHotKey", DJK_MainHotKey)
     JsonUtil.SetIntValue(JsonFileName, "iMeterRotationIncrement", iMeterRotationIncrement)
     JsonUtil.SetIntValue(JsonFileName, "DJK_MeterRotation", DJK_MeterRotation)
     JsonUtil.SetIntValue(JsonFileName, "DJK_MeterZoom", DJK_MeterZoom)
     JsonUtil.SetIntValue(JsonFileName, "DJK_MeterPosX", DJK_MeterPosX)
     JsonUtil.SetIntValue(JsonFileName, "DJK_MeterPosY", DJK_MeterPosY)
     JsonUtil.SetIntValue(JsonFileName, "UpKey", UpKey)
     JsonUtil.SetIntValue(JsonFileName, "DownKey", DownKey)
     JsonUtil.SetIntValue(JsonFileName, "LeftKey", LeftKey)
     JsonUtil.SetIntValue(JsonFileName, "RightKey", RightKey)
     JsonUtil.SetIntValue(JsonFileName, "RotateModKey", RotateModKey)
     JsonUtil.SetIntValue(JsonFileName, "ZoomModKey", ZoomModKey)
     JsonUtil.SetIntValue(JsonFileName, "SaveMeterPosKey", SaveMeterPosKey)

     JsonUtil.SetIntValue(JsonFileName, "DJK_HotkeyActive", DJK_HotkeyActive As Int)
     JsonUtil.SetIntValue(JsonFileName, "bShowMeter", bShowMeter As Int)
     JsonUtil.SetIntValue(JsonFileName, "DJK_ShowNotifications", DJK_ShowNotifications As Int)
     
     JsonUtil.Save(JsonFileName)
     If Messages == 1
        Debug.Notification(ConfirmMsg)
     ElseIf Messages == 2
        Debug.MessageBox(ConfirmMsg)
     Endif
    
EndFunction

Function LoadFromJson(String JsonFileName, Int Messages = 0, String JsonCorruptedWarning = "Json file is corrupted. Load cancelled", String SettingNotFoundWarning = "Settings not found", String ConfirmMsg = "")
    If JsonUtil.JsonExists(JsonFileName)

        JsonUtil.Load(JsonFileName)
        Utility.WaitMenuMode(0.5)

        If JsonUtil.IsGood(JsonFileName) == False
            If Messages == 1
                Debug.Notification(JsonCorruptedWarning)
            ElseIf Messages == 2
                Debug.MessageBox(JsonCorruptedWarning)
            Endif

            JsonUtil.ClearAll(JsonFileName)
            Utility.WaitMenuMode(0.5)
            Return
        Endif
    Else
        If Messages == 1
            Debug.Notification(SettingNotFoundWarning)
        ElseIf Messages == 2
            Debug.MessageBox(SettingNotFoundWarning)
        Endif

        Utility.WaitMenuMode(0.5)
        Return
    Endif 

    DJK_Races = New Race[128]
        
    DJK_JumpHeightMin = New Float[128]
    DJK_JumpHeightMax = New Float[128]
    DJK_JumpMeterSpeed = New Float[128]
    DJK_JumpHeightUnCappedIncrement = New Float[128]
    DJK_fJumpFallHeightMin = New Float[128]
    DJK_fJumpStaminaRate = New Float[128]
    DJK_SprintJumpSpeedMult = New Float[128]
    DJK_SprintJumpSpeedBonus = New Float[128]
    DJK_fSpeedBonusDelay = New Float[128]
   
    Float DJK_JumpHeightMinDefault = Game.GetGameSettingFloat("fJumpHeightMin") / 2
    Float DJK_JumpHeightMaxDefault = Game.GetGameSettingFloat("fJumpHeightMin") * 2 
    Float DJK_fJumpFallHeightMinDefault = Game.GetGameSettingFloat("fJumpFallHeightMin")
    
    If DJK_JumpHeightMinDefault < 1.1 
        DJK_JumpHeightMinDefault = 1.1 
    Endif 
    
    If DJK_JumpHeightMaxDefault < DJK_JumpHeightMinDefault
        DJK_JumpHeightMaxDefault = DJK_JumpHeightMinDefault
    Endif 
    
    DJK_JumpHeightMin[0] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_JumpHeightMin" + 0), DJK_JumpHeightMinDefault)
    DJK_JumpHeightMax[0] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_JumpHeightMax" + 0),  DJK_JumpHeightMaxDefault)
    DJK_JumpMeterSpeed[0] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_JumpMeterSpeed" + 0), 1.5)
    DJK_JumpHeightUnCappedIncrement[0] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_JumpHeightUnCappedIncrement" + 0), 3.0)
    DJK_fJumpFallHeightMin[0] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_fJumpFallHeightMin" + 0), DJK_fJumpFallHeightMinDefault)
    DJK_fJumpStaminaRate[0] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_fJumpStaminaRate" + 0), 0.1)
    DJK_SprintJumpSpeedBonus[0] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_SprintJumpSpeedBonus" + 0), 75.0)
    DJK_fSpeedBonusDelay[0] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_fSpeedBonusDelay" + 0), 2.0)
    
    Int I = 1 
    Int ArrayIndex = 1
    While I < 128 
        Race akRace = JsonUtil.GetFormValue(JsonFileName, ("DJK_Races" + I)) as race
        If akRace 
            DJK_Races[ArrayIndex] = akRace
            DJK_JumpHeightMin[ArrayIndex] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_JumpHeightMin" + I), DJK_JumpHeightMinDefault)
            DJK_JumpHeightMax[ArrayIndex] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_JumpHeightMax" + I), DJK_JumpHeightMaxDefault)
            DJK_JumpMeterSpeed[ArrayIndex] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_JumpMeterSpeed" + I), 1.5)
            DJK_JumpHeightUnCappedIncrement[ArrayIndex] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_JumpHeightUnCappedIncrement" + I), 3.0)
            DJK_fJumpFallHeightMin[ArrayIndex] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_fJumpFallHeightMin" + I), DJK_fJumpFallHeightMinDefault)
            DJK_fJumpStaminaRate[ArrayIndex] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_fJumpStaminaRate" + I), 0.1)
            DJK_SprintJumpSpeedBonus[ArrayIndex] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_SprintJumpSpeedBonus" + I), 75.0)
            DJK_fSpeedBonusDelay[ArrayIndex] = JsonUtil.GetFloatValue(JsonFileName, ("DJK_fSpeedBonusDelay" + I), 2.0)
            ArrayIndex += 1
        Endif 
        I += 1
    EndWhile
            
    ;DJK_AddRaceIndex = (ArrayIndex - 1)
    
    DJK_MainHotKey = JsonUtil.GetIntValue(JsonFileName, "DJK_MainHotKey")
    iMeterRotationIncrement = JsonUtil.GetIntValue(JsonFileName, "iMeterRotationIncrement")
    DJK_MeterRotation = JsonUtil.GetIntValue(JsonFileName, "DJK_MeterRotation")
    DJK_MeterZoom = JsonUtil.GetIntValue(JsonFileName, "DJK_MeterZoom")
    DJK_MeterPosX = JsonUtil.GetIntValue(JsonFileName, "DJK_MeterPosX")
    DJK_MeterPosY = JsonUtil.GetIntValue(JsonFileName, "DJK_MeterPosY")
    UpKey = JsonUtil.GetIntValue(JsonFileName, "UpKey")
    DownKey = JsonUtil.GetIntValue(JsonFileName, "DownKey")
    LeftKey = JsonUtil.GetIntValue(JsonFileName, "LeftKey")
    RightKey = JsonUtil.GetIntValue(JsonFileName, "RightKey")
    RotateModKey = JsonUtil.GetIntValue(JsonFileName, "RotateModKey")
    ZoomModKey = JsonUtil.GetIntValue(JsonFileName, "ZoomModKey")
    
    DJK_HotkeyActive = JsonUtil.GetIntValue(JsonFileName, "DJK_HotkeyActive") As Bool
    bShowMeter = JsonUtil.GetIntValue(JsonFileName, "bShowMeter") As Bool
    DJK_ShowNotifications = JsonUtil.GetIntValue(JsonFileName, "DJK_ShowNotifications") As Bool
    
    Game.SetGameSettingFloat("fJumpFallHeightMin", DJK_fJumpFallHeightMin[DJK_RaceIndex]) 
    
    DestroyJumpMeter() 
    CreateJumpMeter()
    
    If Messages == 1
        Debug.Notification(ConfirmMsg)
    ElseIf Messages == 2
        Debug.MessageBox(ConfirmMsg)
    Endif
EndFunction  

Bool Function ISGodModeEnabled() 
    ;Return PO3_SKSEFunction.GetGodMode() ;only available on SSE
    Return False 
EndFunction
